<?php
define("BASE_API_URL",'https://www.couponsindemand.com/api/v1/index.cfm/coupons?subdomain=');

add_filter('query_vars', 'query_vars');
function query_vars($public_query_vars) {
	$public_query_vars[] = "id";
	return $public_query_vars;
}

function array_sort_by_column_asc(&$array, $column, $direction = SORT_ASC) {
    $reference_array = array();
    foreach($array as $key => $row) {
        $reference_array[$key] = $row[$column];
    }
    array_multisort($reference_array, $direction, $array);
}

function array_sort_by_column_desc(&$array, $column, $direction = SORT_DESC) {
    $reference_array = array();
    foreach($array as $key => $row) {
        $reference_array[$key] = $row[$column];
    }
    array_multisort($reference_array, $direction, $array);
}

function load_scripts_and_styles()
{
	wp_enqueue_script('jquery');
	wp_enqueue_script('google-maps','http://maps.google.com/maps/api/js?sensor=true');
}
add_action('wp_enqueue_scripts', 'load_scripts_and_styles');


function get_couponlist( $atts ) {
	
	?>
	<div id="fb-root">
	</div>		
	<script>
		(function(d, s, id){
		    var js, fjs = d.getElementsByTagName(s)[0];
		    if (d.getElementById(id)) 
			return;
		    js = d.createElement(s);
		    js.id = id;
		    js.src = "//connect.facebook.net/en_US/all.js#xfbml=1&appId=489652497789023";
		    fjs.parentNode.insertBefore(js, fjs);
		}(document, 'script', 'facebook-jssdk'));
	</script>
	<?php
	$a = shortcode_atts( array(
        'group' => '',
		'client' => '',
        'subcategory' => '',
		'category' => '',
		'couponid' => 0,
		'page' => 1,
		'limit' => 20,
		'city' => '',
		'state' => ''
    ), $atts );
	
	$api_data=get_data();
	$location = $api_data -> locations;
	$file_type = $api_data -> file_type;
	$conf = $api_data -> configuration_setting;
	$social_sharing = $api_data -> social;
	$subdomain=$api_data->subdomain;
	$sort_by=get_sort_value($api_data->display_order);
	$url = BASE_API_URL.$subdomain;
	if( $a['group'] != "") {
		$url = $url.'&group='.urlencode($a['group']);
	}
	if( $a['client'] != "") {
		$url = $url.'&client='.urlencode($a['client']);
	}
	if( $a['subcategory'] != "") {
		$url = $url.'&subcategory='.urlencode($a['subcategory']);
	}
	if( $a['category'] != "") {
		$url = $url.'&category='.urlencode($a['category']);
	}
	if( $a['couponid'] != 0) {
		$url = $url.'&couponid='.$a['couponid'];
	}
	if( $a['page'] != 1) {
		$url = $url.'&page='.$a['page'];
	}
	if( $a['limit'] != 20) {
		$url = $url.'&limit='.$a['limit'];
	}
	if( $a['city'] != "") {
		$url = $url.'&city='.urlencode($a['city']);
	}
	if( $a['state'] != "") {
		$url = $url.'&state='.urlencode($a['state']);
	}
	//echo $url;
	//$url = urlencode($url);
	//echo $url;
	
	$json=get_url_data($url);
	if($conf == "Stacked wide") {
		wp_enqueue_style('coupon-stacked-style', plugins_url('css/cid-responsive.css', __FILE__));
	} else {		
		wp_enqueue_style('coupon-side-by-side-style', plugins_url('css/cid-percentage.css', __FILE__));
	}
	/*
	$uri = $_SERVER['REQUEST_URI'];
	$uri_split = explode("/",$uri)[1];
	*/
	$uri = $_SERVER['REQUEST_URI'];
	$uri_split = explode("/",$uri);
	$uri_split = $uri_split[1];
	

	?>
	<div id="CID-msg-Div" style="display:none;">Geolocation API is not supported in your browser.</div>
	<script type="text/javascript">
		var lat1,lon1;
		if (!navigator.geolocation)
		{ 
			jQuery("#CID-msg-Div").show();
			setTimeout(function(){
				jQuery("#CID-msg-Div").fadeOut("slow", function () {
					jQuery("#CID-msg-Div").remove();
				});
			}, 2500);
		}
		function getlocation(){
			if (navigator.geolocation)
			{
				navigator.geolocation.getCurrentPosition(showPosition);
			}
		}
		function GeoSuccess(k,v,lat2,lon2,lat1,lon1) {
			var data = {
				action: "my_action",
				lat1 :lat1,
				lon1 :lon1,
				lat2 :lat2,
				lon2 :lon2
			};
			var ajaxurl = '<?php echo admin_url('admin-ajax.php'); ?>';
			jQuery.post(ajaxurl, data, function(response) {
				var mile_string = "<p>"+response+"</p>"
				jQuery("#CID-location_"+k+"_"+v).html(mile_string);
			});
		}
	</script>
	<input type="hidden" name="subdomain_id" value="<?php echo $subdomain?>" id="subdomain_id"/>
	<div class="CID-rounded-corner-white">		
		<div id="CID-wrapper">
			<div id="CID-columns">
				<?php $couponCount =0;
				if($json){
					$coupon_count = count($json);
					if($sort_by == "recent" or $sort_by == "expiring"){
						for($i=0; $i<$coupon_count; $i++)
						{
							if($sort_by == "recent")
								$a = new DateTime($json[$i]['UPDATEDATE']); 
							if($sort_by == "expiring")
								$a = new DateTime($json[$i]['EXPIRYDATE']); 
							$coupon_newest_array[] = array($json[$i]['COUPONID']=>date_format($a, 'Y-m-d H:i:s'));
						}
						if($sort_by == "recent")
							array_sort_by_column_desc($json, 'UPDATEDATE');
						if($sort_by == "expiring")
							array_sort_by_column_asc($json, 'EXPIRYDATE');
					}
					for ($i=0; $i <$coupon_count; $i++) {
						$couponCount= $couponCount + 1;?>
						<div class="CID-coupon">
							<div class="CID-pin">
								<div class="CID-coupon-section">
									<div class="CID-widget CID-widget-one-<?php echo $json[$i]['COUPONID'];?> CID-rounded">
										<img src="<?php echo $json[$i]['COUPONPRINTLOWRESURL'];?>" title="<?php echo $json[$i]['TITLE'];?> <?php echo $json[$i]['SUBTITLE'];?>">
									</div>
									<?php if($social_sharing == "YES") {?>
										
										<script>
											!function(d, s, id){
												var js, fjs = d.getElementsByTagName(s)[0], p = /^http:/.test(d.location) ? 'http' : 'https';
												if (!d.getElementById(id)) {
													js = d.createElement(s);
													js.id = id;
													js.src = p + '://platform.twitter.com/widgets.js';
													fjs.parentNode.insertBefore(js, fjs);
												}
											}(document, 'script', 'twitter-wjs');
										</script>
										<a href="https://twitter.com/share" class="twitter-share-button" data-url="<?php echo $json[$i]['COUPONDETAILURL'];?>" data-text="<?php echo $json[$i]['TITLE'];?> <?php echo $json[$i]['SUBTITLE'];?>" data-via="CouponsInDemand" data-hashtags="Coupons">
											Tweet
										</a>
										<div class="fb-like" data-href="http://demo2.couponsindemand.com/1000360" data-width="100" data-layout="button_count" data-show-faces="false" data-send="true"></div>

									<?php }?>
								</div>
								<div id="<?php echo $json[$i]['COUPONID'];?>" class="CID-location">
									<?php if(count($json[$i]['LOCATIONS']) > 0 && $location == "YES") {?>
										<ul id="CID-locations">
											<?php foreach ($json[$i]['LOCATIONS'] as $k => $v) {?>
												<li data-geo-lat="<?php echo $v['LATITUDE']?>" data-geo-long="<?php echo $v['LONGITUDE']?>">
													<h3>
														<?php echo $v['NAME'];?>
													</h3>
													<p>
														<?php if($v['ADDR1']) {
															echo $v['ADDR1'];
															?><br><?php
														}
														if($v['ADDR2']) {
															echo $v['ADDR2'];
															?><br><?php
														}
														if($v['ADDR3']) {
															echo $v['ADDR3'];
															?><br><?php
														}
														if($v['CITY']) {
															echo $v['CITY'];
														}
														if($v['STATEABBR']) {
															echo ', '.$v['STATEABBR'];
														}
														if($v['POSTALCODE']) {
															echo ' '.$v['POSTALCODE'];
														}?>
														<div id="CID-location_<?php echo $i;?>_<?php echo $k;?>">
														</div>
														<script type="text/javascript">
															getlocation();
															function showPosition(position)
																{  
																	GeoSuccess(<?php echo $i;?>,<?php echo $k;?>,<?php echo $v['LATITUDE']?>,<?php echo $v['LONGITUDE'];?>,position.coords.latitude,position.coords.longitude);
																}
														</script>
													</p><!---#locIdx.PhoneMain#--->
												</li>
											<?php }?>
										</ul>
										<div class="CID-map_canvas" id="CID-map_canvas_<?php echo $json[$i]['COUPONID'];?>">
										</div>
									<?php } ?>
								</div>
							</div>
						</div>
					<?php }
				}else {
					?><center><h1>Sorry, we currently have not published any coupons.  Please check back soon.</h1></center><?php
				}?>
			</div>
			<div class="clr"></div>
		</div>
		<script type='text/javascript'>
			var loc= "<?php echo $location?>";
			var file_type= "<?php echo $file_type?>";
			if(loc == "NO")
			{
				jQuery(".CID-coupon-section").css("width", "auto");
				jQuery(".CID-coupon-section").css("float", "none");
			}
			<?php for ($i=0; $i <count($json) ; $i++) {?>
				jQuery(function() {
					var el, tempDiv, tempButton, divHeight = 0;
					
					
					<?php if( $subdomain != "iDcards" ) {?>
					jQuery.fn.middleBoxButton = function(text, url) {
						return jQuery(this).hover(function(e) {
							el = jQuery(this).css("border-color", "white");
							divHeight = el.height() + parseInt(el.css("padding-top")) + parseInt(el.css("padding-bottom"));
							tempDiv = jQuery("<div />", {
								"class": "CID-overlay"
							});
							tempButton = jQuery("<a />", {
								"href": url,
								"target": "_blank",
								"text": text,
								"class": "CID-widget-button CID-rounded",
								"css": {
									"top": (divHeight / 2) - 7 + "px"
									}
							}).appendTo(tempDiv);
							tempDiv.appendTo(el);
						}, function(e) {
							el = jQuery(this).css("border-color", "#999");
							jQuery(".CID-overlay").fadeOut("fast", function() {
								jQuery(this).remove();
							})
						});
					}					
					jQuery(".CID-widget-one-<?php echo $json[$i]['COUPONID'];?>").middleBoxButton("GET COUPON", "<?php echo $json[$i]['COUPONPRINTHIGHRESURL'];?>");
					<?php }?>
					
					<?php if(count($json[$i]['LOCATIONS']) > 0 && $location == "YES") {?>
						var default_<?php echo $json[$i]['COUPONID'];?>_loc = new google.maps.LatLng(41.924832, -87.697456),
						pointToMoveTo, 
						first = true,
						curMarker_<?php echo $json[$i]['COUPONID'];?> = new google.maps.Marker({}),
						el;
						var myOptions_<?php echo $json[$i]['COUPONID'];?> = {
							zoom: 10,
							center: default_<?php echo $json[$i]['COUPONID'];?>_loc,
							mapTypeId: google.maps.MapTypeId.ROADMAP
						};
						var map_<?php echo $json[$i]['COUPONID'];?> = new google.maps.Map(jQuery("#CID-map_canvas_<?php echo $json[$i]['COUPONID'];?>")[0], myOptions_<?php echo $json[$i]['COUPONID'];?>);
						jQuery("#<?php echo $json[$i]['COUPONID'];?> #CID-locations li").mouseenter(function() {
							el = jQuery(this);
							if (!el.hasClass("hover")) {
								jQuery("#<?php echo $json[$i]['COUPONID'];?> #CID-locations li").removeClass("hover");
								el.addClass("hover");
								if (!first) { 
									// Clear current marker
									curMarker_<?php echo $json[$i]['COUPONID'];?>.setMap(); 
									// Set zoom back to Chicago level
									// map.setZoom(10);
								}
								// Move (pan) map to new location
								pointToMoveTo = new google.maps.LatLng(el.attr("data-geo-lat"), el.attr("data-geo-long"));
								map_<?php echo $json[$i]['COUPONID'];?>.panTo(pointToMoveTo);
								// Add new marker
								curMarker_<?php echo $json[$i]['COUPONID'];?> = new google.maps.Marker({
									position: pointToMoveTo,
									map: map_<?php echo $json[$i]['COUPONID'];?>,
									icon: "/<?php echo $uri_split?>/wp-content/plugins/CouponsInDemand/images/google_pointer.png"
								});
								// On click, zoom map
								google.maps.event.addListener(curMarker_<?php echo $json[$i]['COUPONID'];?>, 'click', function() {
									map_<?php echo $json[$i]['COUPONID'];?>.setZoom(14);
								});
								// No longer the first time through (re: marker clearing)        
								first = false; 
							}
						});
						jQuery("#<?php echo $json[$i]['COUPONID'];?> #CID-locations li:first").trigger("mouseenter");
					<?php }?>
				});
			<?php }?>
		</script>
	</div>
<?php }

if(isset($_REQUEST['action']) && $_REQUEST['action']=='my_action') {
	my_action_callback();
}

function my_action_callback() {
	$start[]=$_REQUEST['lat1'];
	$start[]=$_REQUEST['lon1'];
	$finish[]=$_REQUEST['lat2'];
	$finish[]=$_REQUEST['lon2'];
	echo $distance = Haversine($start, $finish).' miles away';
	die(); // this is required to return a proper result
}
add_action('wp_ajax_my_action', 'my_action_callback');

function get_url_data($url){
    $args = array(
    'timeout'     => 5,
    'redirection' => 5,
    'httpversion' => '1.0',
    'user-agent'  => 'WordPress/' . $wp_version . '; ' . get_bloginfo( 'url' ),
    'blocking'    => true,
    'headers'     => array(),
    'cookies'     => array(),
    'body'        => null,
    'compress'    => false,
    'decompress'  => true,
    'sslverify'   => false,
    'stream'      => false,
    'filename'    => null
  );
  $response = wp_remote_get( $url, $args );
   if(is_array($response) && array_key_exists('body', $response))
	{
		$result = preg_replace('/.+?({.+}).+/','$1',$response['body']);
		$result="[".$result."]";
		$data = json_decode($result, true);
		return $data;
	}
	return FALSE;
}

function get_sort_value($val) {
	switch($val){
		case 'Newest':
			$sort='recent';
		break;
		case 'Popular':
			$sort='popular';
		break;
		case 'Expire Soon':
			$sort='expiring';
		break;
	}
	return $sort;
}

function get_data(){
	global $wpdb;
	$id=1;
	$data=$wpdb->get_row($wpdb->prepare("SELECT * FROM ".$wpdb->prefix . "cid_configuration WHERE id = %d", $id));
	return $data;
}

function Haversine($start, $finish) {
	$theta = $start[1] - $finish[1]; 
	$distance = (sin(@deg2rad($start[0])) * sin(@deg2rad($finish[0]))) + (cos(@deg2rad($start[0])) * cos(@deg2rad($finish[0])) * cos(@deg2rad($theta))); 
	$distance = acos($distance); 
	$distance = rad2deg($distance); 
	$distance = $distance * 60 * 1.1515; 
	return round($distance, 2);
}

if (!is_admin()) {
	add_shortcode('CouponsInDemand', 'get_couponlist');
}?>
